      Subroutine Init
      Implicit None

      Include 'commons.inc'

C     Generate An Initial Configuration
C     Not An Eqwuilibrium Configuration, But Just Avoid Overlaps

      Logical Laccept
      Integer I,J,Ipart,Ib,Selectint
      Double Precision Fac,Ran_Uniform,Xi,Yi,Zi,Rxn,Ryn,Rzn,Unew,Uold

      Fac = Box(1)**3/(Box(1)**3 + Box(2)**3)

      Npbox(1) = 0
      Npbox(2) = 0

C     Generate Random Coordinates And 
C     Place Particles In A Certain Box

      Do I=1,Npart

         If(Ran_Uniform().Lt.Fac) Then
            Ibox(I) = 1
         Else
            Ibox(I) = 2
         Endif

C     Number Of Particles Per Box, This Included The Fractional One
         
         Npbox(Ibox(I)) = Npbox(Ibox(I)) + 1

         Rx(I) = Box(Ibox(I))*Ran_Uniform()
         Ry(I) = Box(Ibox(I))*Ran_Uniform()
         Rz(I) = Box(Ibox(I))*Ran_Uniform()
      Enddo

C     Monte Carlo Displacements To Remove Initial Overlaps
C     On Average 50 Displacements Per Particle

      Do J=1,Npart*50
         Ipart = Selectint(Npart)
         Ib    = Ibox(Ipart)

C     Random Displacement Maximum Dispacement Fixed
         
         Rxn = Rx(Ipart) + Ran_Uniform() - 0.5d0
         Ryn = Ry(Ipart) + Ran_Uniform() - 0.5d0
         Rzn = Rz(Ipart) + Ran_Uniform() - 0.5d0

         If(Rxn.Lt.0.0d0) Then
            Rxn = Rxn + Box(Ib)
         Elseif(Rxn.Gt.Box(Ib)) Then
            Rxn = Rxn - Box(Ib)
         Endif

         If(Ryn.Lt.0.0d0) Then
            Ryn = Ryn + Box(Ib)
         Elseif(Ryn.Gt.Box(Ib)) Then
            Ryn = Ryn - Box(Ib)
         Endif

         If(Rzn.Lt.0.0d0) Then
            Rzn = Rzn + Box(Ib)
         Elseif(Rzn.Gt.Box(Ib)) Then
            Rzn = Rzn - Box(Ib)
         Endif

         Xi = Rx(Ipart)
         Yi = Ry(Ipart)
         Zi = Rz(Ipart)

C     Assume That All Particles Are Real Particles
         
         Call Epart(Ib,Uold,Xi,Yi,Zi,Ipart,1.0d0)
         Call Epart(Ib,Unew,Rxn,Ryn,Rzn,Ipart,1.0d0)

C     Assume The Temperature Is 2 So No Phase Transitions Initially
         
         Call Accept(Dexp(-0.5d0*(Unew-Uold)),Laccept)

         If(Laccept) Then
            Rx(Ipart) = Rxn
            Ry(Ipart) = Ryn
            Rz(Ipart) = Rzn
         Endif
      Enddo

      Return
      End
